## libnewlib-nano 2.11.2

=== meson_options.txt ===
option('target-optspace', type: 'boolean', value: false,
       description: 'Compile with -Os')

option('multilib', type: 'boolean', value: true,
       description: 'Enable multilib compile')

option('hw-fp', type: 'boolean', value: false,
	description: 'Turn on hardware floating point math')

option('have-alias-attribute', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
       description: 'Compiler supports __alias__ attribute')

option('tests', type: 'boolean', value: false,
       description: 'Enable tests')

option('newlib-tinystdio', type: 'boolean', value: false,
       description: 'Use tiny stdio from avr libc')

option('newlib-io-pos-args', type: 'boolean', value: false,
       description: 'enable printf-family positional arg support')
option('newlib-io-c99-formats', type: 'boolean', value: false,
       description: 'enable C99 support in IO functions like printf/scanf')
option('newlib-register-fini', type: 'boolean', value: false,
       description: 'enable finalization function registration using atexit')
option('newlib-io-long-long', type: 'boolean', value: false,
       description: 'enable long long type support in IO functions like printf/scanf')
option('newlib-io-long-double', type: 'boolean', value: false,
       description: 'enable long double type support in IO functions printf/scanf')
option('newlib-mb', type: 'boolean', value: false,
       description: 'enable multibyte support')
option('newlib-iconv-encodings', type: 'boolean', value: false,
       description: 'enable specific comma-separated list of bidirectional iconv encodings to be built-in')
option('newlib-iconv-from-encodings', type: 'boolean', value: false,
       description: 'enable specific comma-separated list of "from" iconv encodings to be built-in')
option('newlib-iconv-to-encodings', type: 'boolean', value: false,
       description: 'enable specific comma-separated list of "to" iconv encodings to be built-in')
option('newlib-iconv-external-ccs', type: 'boolean', value: false,
       description: 'enable capabilities to load external CCS files for iconv')
option('newlib-atexit-dynamic-alloc', type: 'boolean', value: false,
       description: 'enable dynamic allocation of atexit entries')
option('newlib-global-atexit', type: 'boolean', value: false,
       description: 'enable atexit data structure as global')
option('newlib-reent-small', type: 'boolean', value: false,
       description: 'enable small reentrant struct support')
option('newlib-global-stdio-streams', type: 'boolean', value: false,
       description: 'enable global stdio streams')
option('newlib-fvwrite-in-streamio', type: 'boolean', value: false,
       description: 'disable iov in streamio')
option('newlib-fseek-optimization', type: 'boolean', value: false,
       description: 'disable fseek optimization')
option('newlib-wide-orient', type: 'boolean', value: false,
       description: 'Turn off wide orientation in streamio')
option('newlib-nano-malloc', type: 'boolean', value: false,
       description: 'use small-footprint nano-malloc implementation')
option('newlib-unbuf-stream-opt', type: 'boolean', value: false,
       description: 'enable unbuffered stream optimization in streamio')
option('lite-exit', type: 'boolean', value: false,
       description: 'enable light weight exit')
option('newlib-nano-formatted-io', type: 'boolean', value: false,
       description: 'Use nano version formatted IO')
option('newlib-retargetable-locking', type: 'boolean', value: false,
       description: 'Allow locking routines to be retargeted at link time')
option('newlib-long-time_t', type: 'boolean', value: false,
       description: 'define time_t to long')
option('newlib-multithread', type: 'boolean', value: false,
       description: 'enable support for multiple threads')
option('newlib-iconv', type: 'boolean', value: false,
       description: 'enable iconv library support')
option('newlib-io-float', type: 'boolean', value: false,
       description: 'enable printf/scanf family float support')
option('newlib-supplied-syscalls', type: 'boolean', value: false,
       description: 'enable newlib supplied syscalls')
option('newlib-elix-level', type: 'integer', value: 0,
       description: 'desired elix library level (0-4)')
option('newlib-reentrant-syscalls-provided', type: 'boolean', value: false,
       description: 'system provides reentrant syscall API')
option('newlib-missing-syscall-names', type: 'boolean', value: false,
       description: 'system only provides regular syscall API')
option('newlib-locale-info', type: 'boolean', value: false,
       description: 'locale support')
option('newlib-locale-info-extended', type: 'boolean', value: false,
       description: 'extended locale support')
option('newlib-global-errno', type: 'boolean', value: false,
       description: 'use global errnor variable')

=== debian/changelog ===
libnewlib-nano (2.11.2-1) unstable; urgency=medium

  * 2.11.2 upstream release
  * Refactor meson and tinystdio changes
  * Make tinystdio pass printf/scanf tests

 -- Keith Packard <keithp@keithp.com>  Sun, 14 Oct 2018 22:26:58 -0700

libnewlib-nano (2.10.0-1) unstable; urgency=medium

  * Initial release

 -- Keith Packard <keithp@keithp.com>  Sat, 04 Aug 2018 18:37:23 +0800

=== debian/control ===
Source: libnewlib-nano
Priority: optional
Maintainer: Keith Packard <keithp@keithp.com>
Build-Depends: debhelper (>= 11), gcc-arm-none-eabi, meson, ninja-build
Standards-Version: 4.1.3
Section: devel

Package: libnewlib-nano-arm-none-eabi
Architecture: all
Depends: ${misc:Depends}
Description: Smaller embedded C library for arm development
 Newlib with all of the shrinking options enabled and stdio
 bits adapted from gcc-avr

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

BUILDDIR=build-nano

%:
	dh $@ -B$(BUILDDIR)

ARCH=arm-none-eabi

MESON_FLAGS = \
	--prefix=/usr \
	--cross-file debian/cross-$(ARCH).txt \
	--buildtype plain \
	-Dtarget-optspace=true \
	-Dnewlib-tinystdio=true \
	-Dnewlib-supplied-syscalls=false \
	-Dnewlib-reentrant-small=true\
	-Dnewlib-wide-orient=false\
	-Dnewlib-nano-malloc=true\
	-Dlite-exit=true\
	-Dnewlib-global-atexit=true\
	-Dincludedir=lib/newlib-nano/$(ARCH)/include \
	-Dlibdir=lib/newlib-nano/$(ARCH)/lib 

override_dh_autoreconf:
	echo 'no reconf needed'

override_dh_auto_clean:
	rm -fr debian/$(BUILDDIR)

override_dh_auto_configure:
	meson . debian/$(BUILDDIR) $(MESON_FLAGS)

override_dh_auto_build:
	cd debian/$(BUILDDIR) && ninja

override_dh_auto_test:
	cd debian/$(BUILDDIR) && ninja test

override_dh_auto_install:
	cd debian/$(BUILDDIR) && DESTDIR=${CURDIR}/debian/libnewlib-nano-arm-none-eabi ninja install
